using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class WeightConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型
		[ProtoMember(3)]
		public uint Type { get; set; } // 类型
		[ProtoMember(4)]
		public uint Weight { get; set; } // 重量(克)  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<WeightConfig> Context => ConfigTableHelper.Table<WeightConfig>();

        public static WeightConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static WeightConfig Get(Predicate<WeightConfig> match)
        {
            return Context.Get(match);
        }
        
        public static WeightConfig Fist()
        {
            return Context.Fist();
        }

        public static WeightConfig Last()
        {
            return Context.Last();
        }

        public static WeightConfig Fist(Predicate<WeightConfig> match)
        {
            return Context.Fist(match);
        }

        public static WeightConfig Last(Predicate<WeightConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<WeightConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<WeightConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<WeightConfig> GetList(Predicate<WeightConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<WeightConfig>(arr);
        }
        #endregion
    }
}